Botan 2.13.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Botan::RSA_PublicKey Class Reference

`#include <rsa.h>`

Inheritance diagram for Botan::RSA_PublicKey:

## Public Member Functions
std::string | algo_name () const override
AlgorithmIdentifier | algorithm_identifier () const override
bool | check_key (RandomNumberGenerator &rng, bool) const override
std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &params, const std::string &provider) const override
virtual Signature_Format | default_x509_signature_format () const
size_t | estimated_strength () const override
std::string | fingerprint_public (const std::string &alg="SHA-256") const
const BigInt & | get_e () const
const BigInt & | get_n () const
virtual OID | get_oid () const
size_t | key_length () const override
virtual size_t | message_part_size () const
virtual size_t | message_parts () const
std::shared_ptr< const RSA_Public_Data > | public_data () const
std::vector< uint8_t > | public_key_bits () const override
| RSA_PublicKey (const AlgorithmIdentifier &alg_id, const std::vector< uint8_t > &key_bits)
| RSA_PublicKey (const BigInt &n, const BigInt &e)
std::vector< uint8_t > | subject_public_key () const

## Protected Member Functions
void | init (BigInt &&n, BigInt &&e)
| RSA_PublicKey ()=default

## Protected Attributes
std::shared_ptr< const RSA_Public_Data > | m_public

## Detailed Description

RSA Public Key

Definition at line 25 of file rsa.h.

## Constructor & Destructor Documentation

Botan::RSA_PublicKey::RSA_PublicKey | ( | const AlgorithmIdentifier & | alg_id,
|  | const std::vector< uint8_t > & | key_bits
| ) |  |

Load a public key.

Parameters

  alg_id | the X.509 algorithm identifier
  key_bits | DER encoded public key bits

Definition at line 118 of file rsa.cpp.

References Botan::BER_Decoder::decode(), Botan::BER_Decoder::end_cons(), init(), Botan::SEQUENCE, and Botan::BER_Decoder::start_cons().

120 {
121 BigInt n, e;
122 BER_Decoder(key_bits)
123 .start_cons(SEQUENCE)
124 .decode(n)
125 .decode(e)
126 .end_cons();
127
128 init(std::move(n), std::move(e));
129 }
Botan::SEQUENCE
Definition: asn1_obj.h:40
Botan::RSA_PublicKey::init
void init(BigInt &&n, BigInt &&e)
Definition: rsa.cpp:111

Botan::RSA_PublicKey::RSA_PublicKey | ( | const BigInt & | n,
|  | const BigInt & | e
| ) |  |

Create a public key.

- n the modulus
- e the exponent

Definition at line 131 of file rsa.cpp.

References init().

132 {
133 BigInt n = modulus;
134 BigInt e = exponent;
135 init(std::move(n), std::move(e));
136 }
Botan::RSA_PublicKey::init
void init(BigInt &&n, BigInt &&e)
Definition: rsa.cpp:111

Botan::RSA_PublicKey::RSA_PublicKey | ( |  | ) |
| protected default

## Member Function Documentation

std::string Botan::RSA_PublicKey::algo_name | ( |  | ) | const
| inline override virtual

Get the name of the underlying public key scheme.

Returns
  name of the public key scheme

Implements Botan::Public_Key.

Definition at line 43 of file rsa.h.

Referenced by Botan::RSA_PrivateKey::create_decryption_op(), create_encryption_op(), Botan::RSA_PrivateKey::create_kem_decryption_op(), create_kem_encryption_op(), Botan::RSA_PrivateKey::create_signature_op(), create_verification_op(), and Botan::RSA_PrivateKey::RSA_PrivateKey().

43 { return "RSA"; }

AlgorithmIdentifier Botan::RSA_PublicKey::algorithm_identifier | ( |  | ) | const
| override virtual

Returns
  X.509 AlgorithmIdentifier for this key

Implements Botan::Public_Key.

Definition at line 148 of file rsa.cpp.

References Botan::Public_Key::get_oid(), and Botan::AlgorithmIdentifier::USE_NULL_PARAM.

149 {
150 return AlgorithmIdentifier(get_oid(), AlgorithmIdentifier::USE_NULL_PARAM);
151 }
Botan::Public_Key::get_oid
virtual OID get_oid() const
Definition: pk_keys.cpp:53
Botan::AlgorithmIdentifier::USE_NULL_PARAM
Definition: alg_id.h:24

bool Botan::RSA_PublicKey::check_key | ( | RandomNumberGenerator & | rng,
|  | bool | strong
| ) |  | const
| override virtual

Test the key values for consistency.

Parameters

  rng | rng to use
  strong | whether to perform strong and lengthy version of the test

Returns
  true if the test is passed

Implements Botan::Public_Key.

Reimplemented in Botan::RSA_PrivateKey.

Definition at line 168 of file rsa.cpp.

References get_e(), and get_n().

169 {
170 if(get_n() < 35 || get_n().is_even() || get_e() < 3 || get_e().is_even())
171 return false;
172 return true;
173 }
Botan::RSA_PublicKey::get_n
const BigInt & get_n() const
Definition: rsa.cpp:108
Botan::RSA_PublicKey::get_e
const BigInt & get_e() const
Definition: rsa.cpp:109

std::unique_ptr< PK_Ops::Encryption > Botan::RSA_PublicKey::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 632 of file rsa.cpp.

References algo_name(), and Botan::Exception::what().

635 {
636 #if defined(BOTAN_HAS_OPENSSL)
637 if(provider == "openssl" || provider.empty())
638 {
639 try
640 {
641 return make_openssl_rsa_enc_op(*this, params);
642 }
643 catch(Exception& e)
644 {
645 /*
646 * If OpenSSL for some reason could not handle this (eg due to OAEP params),
647 * throw if openssl was specifically requested but otherwise just fall back
648 * to the normal version.
649 */
650 if(provider == "openssl")
651 throw Lookup_Error("OpenSSL RSA provider rejected key:" + std::string(e.what()));
652 }
653 }
654 #endif
655
656 if(provider == "base" || provider.empty())
657 return std::unique_ptr<PK_Ops::Encryption>(new RSA_Encryption_Operation(*this, params));
658 throw Provider_Not_Found(algo_name(), provider);
659 }
Botan::RSA_PublicKey::algo_name
std::string algo_name() const override
Definition: rsa.h:43

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::RSA_PublicKey::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 662 of file rsa.cpp.

References algo_name().

665 {
666 if(provider == "base" || provider.empty())
667 return std::unique_ptr<PK_Ops::KEM_Encryption>(new RSA_KEM_Encryption_Operation(*this, params));
668 throw Provider_Not_Found(algo_name(), provider);
669 }
Botan::RSA_PublicKey::algo_name
std::string algo_name() const override
Definition: rsa.h:43

std::unique_ptr< PK_Ops::Verification > Botan::RSA_PublicKey::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 672 of file rsa.cpp.

References algo_name().

674 {
675 #if defined(BOTAN_HAS_OPENSSL)
676 if(provider == "openssl" || provider.empty())
677 {
678 std::unique_ptr<PK_Ops::Verification> res = make_openssl_rsa_ver_op(*this, params);
679 if(res)
680 return res;
681 }
682 #endif
683
684 if(provider == "base" || provider.empty())
685 return std::unique_ptr<PK_Ops::Verification>(new RSA_Verify_Operation(*this, params));
686
687 throw Provider_Not_Found(algo_name(), provider);
688 }
Botan::RSA_PublicKey::algo_name
std::string algo_name() const override
Definition: rsa.h:43

virtual Signature_Format Botan::Public_Key::default_x509_signature_format | ( |  | ) | const
| inline virtual inherited

Reimplemented in Botan::GOST_3410_PublicKey.

Definition at line 126 of file pk_keys.h.

References Botan::DER_SEQUENCE, and Botan::IEEE_1363.

Referenced by Botan::X509_Object::choose_sig_format(), and Botan::X509_Object::verify_signature().

127 {
128 return (this->message_parts() >= 2) ? DER_SEQUENCE : IEEE_1363;
129 }
Botan::Public_Key::message_parts
virtual size_t message_parts() const
Definition: pk_keys.h:113
Botan::IEEE_1363
Definition: pk_keys.h:24
Botan::DER_SEQUENCE
Definition: pk_keys.h:24

size_t Botan::RSA_PublicKey::estimated_strength | ( |  | ) | const
| override virtual

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implements Botan::Public_Key.

Definition at line 143 of file rsa.cpp.

References Botan::if_work_factor(), and key_length().

144 {
145 return if_work_factor(key_length());
146 }
Botan::if_work_factor
size_t if_work_factor(size_t bits)
Definition: workfactor.cpp:38
Botan::RSA_PublicKey::key_length
size_t key_length() const override
Definition: rsa.cpp:138

std::string Botan::Public_Key::fingerprint_public | ( | const std::string & | alg = `"SHA-256"` | ) | const
| inherited

Returns
  Hash of the subject public key

Definition at line 77 of file pk_keys.cpp.

References Botan::create_hex_fingerprint(), and Botan::Public_Key::subject_public_key().

78 {
79 return create_hex_fingerprint(subject_public_key(), hash_algo);
80 }
hash_algo
AlgorithmIdentifier hash_algo
Definition: x509_obj.cpp:22
Botan::create_hex_fingerprint
std::string create_hex_fingerprint(const uint8_t bits[], size_t bits_len, const std::string &hash_name)
Definition: pk_keys.cpp:17
Botan::Public_Key::subject_public_key
std::vector< uint8_t > subject_public_key() const
Definition: pk_keys.cpp:38

const BigInt & Botan::RSA_PublicKey::get_e | ( |  | ) | const

Returns
  public exponent

Definition at line 109 of file rsa.cpp.

References m_public.

Referenced by check_key(), Botan::RSA_PrivateKey::check_key(), Botan::RSA_PrivateKey::private_key_bits(), and public_key_bits().

109 { return m_public->get_e(); }
Botan::RSA_PublicKey::m_public
std::shared_ptr< const RSA_Public_Data > m_public
Definition: rsa.h:86

const BigInt & Botan::RSA_PublicKey::get_n | ( |  | ) | const

Returns
  public modulus

Definition at line 108 of file rsa.cpp.

References m_public.

Referenced by check_key(), Botan::RSA_PrivateKey::check_key(), Botan::RSA_PrivateKey::private_key_bits(), and public_key_bits().

108 { return m_public->get_n(); }
Botan::RSA_PublicKey::m_public
std::shared_ptr< const RSA_Public_Data > m_public
Definition: rsa.h:86

OID Botan::Public_Key::get_oid | ( |  | ) | const
| virtual inherited

Get the OID of the underlying public key scheme.

Returns
  OID of the public key scheme

Reimplemented in Botan::XMSS_WOTS_Addressed_PublicKey.

Definition at line 53 of file pk_keys.cpp.

References Botan::Public_Key::algo_name(), Botan::OID::empty(), and Botan::OIDS::str2oid_or_empty().

Referenced by Botan::DL_Scheme_PublicKey::algorithm_identifier(), Botan::Curve25519_PublicKey::algorithm_identifier(), Botan::Ed25519_PublicKey::algorithm_identifier(), Botan::McEliece_PublicKey::algorithm_identifier(), algorithm_identifier(), Botan::GOST_3410_PublicKey::algorithm_identifier(), Botan::EC_PublicKey::algorithm_identifier(), Botan::TPM_PrivateKey::algorithm_identifier(), and Botan::XMSS_WOTS_Addressed_PublicKey::get_oid().

54 {
55 const OID o = OIDS::str2oid_or_empty(algo_name());
56 if(o.empty())
57 throw Lookup_Error("PK algo " + algo_name() + " has no defined OIDs");
58 return o;
59 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0
Botan::OIDS::str2oid_or_empty
BOTAN_UNSTABLE_API OID str2oid_or_empty(const std::string &name)
Definition: oids.cpp:116

void Botan::RSA_PublicKey::init | ( | BigInt && | n,
|  | BigInt && | e
| ) |  |
| protected

Definition at line 111 of file rsa.cpp.

References m_public.

Referenced by Botan::RSA_PrivateKey::RSA_PrivateKey(), and RSA_PublicKey().

112 {
113 if(n.is_negative() || n.is_even() || e.is_negative() || e.is_even())
114 throw Decoding_Error("Invalid RSA public key parameters");
115 m_public = std::make_shared<RSA_Public_Data>(std::move(n), std::move(e));
116 }
Botan::RSA_PublicKey::m_public
std::shared_ptr< const RSA_Public_Data > m_public
Definition: rsa.h:86

size_t Botan::RSA_PublicKey::key_length | ( |  | ) | const
| override virtual

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implements Botan::Public_Key.

Definition at line 138 of file rsa.cpp.

References m_public.

Referenced by estimated_strength().

139 {
140 return m_public->public_modulus_bits();
141 }
Botan::RSA_PublicKey::m_public
std::shared_ptr< const RSA_Public_Data > m_public
Definition: rsa.h:86

virtual size_t Botan::Public_Key::message_part_size | ( |  | ) | const
| inline virtual inherited

Returns how large each of the message parts refered to by message_parts() is

This function is public but applications should have few reasons to ever call this.

Returns
  size of the message parts in bits

Reimplemented in Botan::ECDSA_PublicKey, Botan::GOST_3410_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::SM2_PublicKey, and Botan::DSA_PublicKey.

Definition at line 124 of file pk_keys.h.

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

124 { return 0; }

virtual size_t Botan::Public_Key::message_parts | ( |  | ) | const
| inline virtual inherited

Returns more than 1 if the output of this algorithm (ciphertext, signature) should be treated as more than one value. This is used for algorithms like DSA and ECDSA, where the (r,s) output pair can be encoded as either a plain binary list or a TLV tagged DER encoding depending on the protocol.

This function is public but applications should have few reasons to ever call this.

Returns
  number of message parts

Reimplemented in Botan::ECDSA_PublicKey, Botan::GOST_3410_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::SM2_PublicKey, and Botan::DSA_PublicKey.

Definition at line 113 of file pk_keys.h.

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

113 { return 1; }

std::shared_ptr< const RSA_Public_Data > Botan::RSA_PublicKey::public_data | ( |  | ) | const

Definition at line 103 of file rsa.cpp.

References m_public.

104 {
105 return m_public;
106 }
Botan::RSA_PublicKey::m_public
std::shared_ptr< const RSA_Public_Data > m_public
Definition: rsa.h:86

std::vector< uint8_t > Botan::RSA_PublicKey::public_key_bits | ( |  | ) | const
| override virtual

Returns
  BER encoded public key bits

Implements Botan::Public_Key.

Definition at line 153 of file rsa.cpp.

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), get_e(), get_n(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

154 {
155 std::vector<uint8_t> output;
156 DER_Encoder der(output);
157 der.start_cons(SEQUENCE)
158 .encode(get_n())
159 .encode(get_e())
160 .end_cons();
161
162 return output;
163 }
Botan::RSA_PublicKey::get_n
const BigInt & get_n() const
Definition: rsa.cpp:108
Botan::RSA_PublicKey::get_e
const BigInt & get_e() const
Definition: rsa.cpp:109
Botan::SEQUENCE
Definition: asn1_obj.h:40

std::vector< uint8_t > Botan::Public_Key::subject_public_key | ( |  | ) | const
| inherited

Returns
  X.509 subject key encoding for this key object

Definition at line 38 of file pk_keys.cpp.

References Botan::Public_Key::algorithm_identifier(), Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::Public_Key::public_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::X509::BER_encode(), Botan::PKCS10_Request::create(), Botan::Public_Key::fingerprint_public(), and Botan::X509::PEM_encode().

39 {
40 std::vector<uint8_t> output;
41
42 DER_Encoder(output).start_cons(SEQUENCE)
43 .encode(algorithm_identifier())
44 .encode(public_key_bits(), BIT_STRING)
45 .end_cons();
46
47 return output;
48 }
Botan::Public_Key::public_key_bits
virtual std::vector< uint8_t > public_key_bits() const =0
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0
Botan::SEQUENCE
Definition: asn1_obj.h:40
Botan::BIT_STRING
Definition: asn1_obj.h:35

## Member Data Documentation

std::shared_ptr<const RSA_Public_Data> Botan::RSA_PublicKey::m_public
| protected

Definition at line 86 of file rsa.h.

Referenced by get_e(), get_n(), init(), key_length(), and public_data().

The documentation for this class was generated from the following files:

- src/lib/pubkey/rsa/rsa.h
- src/lib/pubkey/rsa/rsa.cpp